package com.jiuqi.syntax;

import java.util.ArrayList;
import java.util.HashMap;

/* loaded from: com_jiuqi_syntax.jar:com/jiuqi/syntax/Functions.class */
public final class Functions extends ArrayList {
    private HashMap hashFunctions = new HashMap();

    public Function getFunc(int index) {
        return (Function) super.get(index);
    }

    public Function getFunc(String name) {
        return (Function) this.hashFunctions.get(name.toUpperCase());
    }

    public boolean exists(String name) {
        return this.hashFunctions.get(name.toUpperCase()) != null;
    }

    @Override // java.util.ArrayList, java.util.AbstractList, java.util.AbstractCollection, java.util.Collection, java.util.List
    public boolean add(Object obj) {
        boolean b = super.add((Functions) obj);
        if (b) {
            this.hashFunctions.put(((Function) obj).name.toUpperCase(), obj);
        }
        return b;
    }

    public boolean add(Function func) {
        return add((Object) func);
    }

    public Function addFunc(String name, String title) {
        return addFunc(name, title, "", 0);
    }

    public Function addFunc(String name, String title, String description, int resultType) {
        Function func = new Function();
        func.name = name;
        func.title = title;
        func.description = description;
        func.resultType = resultType;
        if (add(func)) {
            return func;
        }
        return null;
    }

    @Override // java.util.ArrayList, java.util.AbstractList, java.util.List
    public Object remove(int index) {
        Object obj = super.remove(index);
        if (obj != null) {
            this.hashFunctions.remove(((Function) obj).name.toUpperCase());
        }
        return obj;
    }
}
